<?php

### Set this and only this constants before use this script

define("LOGIN", "login");		# your login
define("OPTIONS", "");			# default options





##### Automated banner caller
##### Optimized for php3

### Functions

function http($host,$request) {

    $fp=fsockopen($host,80,$errno,$errstr,2);
    if ($fp) {
	fputs($fp, "$request\n");
	$answer=fread($fp,16384);
	fclose($fp);
	return $answer;
    } else {
	return "";
    }
}

function request($login,$mirror,$query,$timeout,$headers,$random) {

    $query=strtr($query," ","+"); # Relpacement for str_replace

    $request="GET /cgi-bin/iframe/$login?$random&ssi=yes$query HTTP/1.0\nHOST: $mirror\n";
    while (list($name,$value)=each($headers)){
	if (strlen($value)>0) { $request=$request."$name: $value\n"; };
    }

    $banner=http($mirror,$request);

    if ((strlen($banner)<=0)||(!ereg("^HTTP\/[^ ]* 200",$banner))) { return ""; };
    list($head,$body) = split("\r?\n\r?\n",$banner,2);
    return $body;
}

function defaultf($login,$mirror,$query,$random) {
    return "<a href=\"http://$mirror/cgi-bin/href/$login?$random\" target=_top><img src=\"http://$mirror/cgi-bin/banner/$login?$random$query\" alt=\"List Banner Exchange\" width=470 height=60 border=0 ismap></a>";
}

function banner($login,$query) {
    global $phpversion,$SOURCE_CHARSET,$SERVER_NAME,$REQUEST_URI,$HTTP_USER_AGENT,$HTTP_X_FORWARDED_FOR,$REMOTE_ADDR;

    $mirror="kbe.rotabanner.com";	    # nearest mirror IP
    $timeout=2;			    	    # timeout in seconds
    list($usec, $sec) = explode(' ', microtime());
    srand((float) $sec + ((float) $usec * 100000));
    $random=rand(0,10000000);	  	    # random number
    $headers=array (
	"REFERER"	    => "http://".$SERVER_NAME.$REQUEST_URI,    		    # we need to pass 
	"USER-AGENT"	    => $HTTP_USER_AGENT,				    # these headers
	"X_FORWARDED_FOR"   => $HTTP_X_FORWARDED_FOR,			    	    # into subrequests
	"REMOTE_ADDR"	    => $REMOTE_ADDR				     	    #
    );

    $query="&charset=$SOURCE_CHARSET".(strlen($query)!=0?"&":"").$query; 	    # Russian Apache charset autodetect
    $return = request($login,$mirror,$query,$timeout,$headers,$random);
    return (strlen($return)>0?$return:defaultf($login,$mirror,$query,$random));
}



### The Main Function 

function show_banner($login = LOGIN,$options = OPTIONS) {
    global $phpversion,$SOURCE_CHARSER,$SERVER_NAME,$REQUEST_URI,$HTTP_USER_AGENT,$HTTP_X_FORWARDED_FOR,$REMOTE_ADDR,$HTTP_SERVER_VARS;

    $phpversion=strtr(phpversion(),".",""); # Relpacement for str_replace

    $SOURCE_CHARSET=$HTTP_SERVER_VARS["SOURCE_CHARSET"];
    $SERVER_NAME=$HTTP_SERVER_VARS["SERVER_NAME"];
    $REQUEST_URI=$HTTP_SERVER_VARS["REQUEST_URI"];
    $HTTP_USER_AGENT=$HTTP_SERVER_VARS["HTTP_USER_AGENT"];
    $HTTP_X_FORWARDED_FOR=$HTTP_SERVER_VARS["HTTP_X_FORWARDED_FOR"];
    $REMOTE_ADDR = $HTTP_SERVER_VARS["REMOTE_ADDR"];

    $banner=banner($login,$options);
    echo $banner;
}

?>
